@echo off
REM ----------------------------------------------------------------------------
REM Define environment variables
REM
set HDS_PROJECT_DIR=%CD%
set HDS_LIBS=%HDS_PROJECT_DIR%\Prefs\hds.hdp
set HDS_USER_HOME=%HDS_PROJECT_DIR%\Prefs\hds_user
set HDS_TEAM_HOME=%HDS_PROJECT_DIR%\Prefs\hds_team

set SIMULATION_DIR=%HDS_PROJECT_DIR:\=/%/Simulation
set SCRATCH_DIR=%USERPROFILE%\Work\Tmp

set HDS_HOME=C:\eda\MentorGraphics\HDS
if "%MODELSIM_HOME%" == "" (
	set MODELSIM_HOME=C:\eda\MentorGraphics\modelsim\win32
	if not exist !MODELSIM_HOME!\ (
	  set MODELSIM_HOME=C:\eda\MentorGraphics\modelsim\win64
	)
)
::set HDS_HOME=C:\tools\eda\HDS
::set MODELSIM_HOME=C:\tools\eda\Modelsim\win64

REM ----------------------------------------------------------------------------
REM Prepare scratch directory
REM
rmdir /S /Q "%SCRATCH_DIR%\%DESIGN_NAME%"
mkdir "%SCRATCH_DIR%\%DESIGN_NAME%"

REM ----------------------------------------------------------------------------
REM Delete intermediate files
REM
del /s %HDS_PROJECT_DIR%\*.bak %HDS_PROJECT_DIR%\*.lck %HDS_PROJECT_DIR%\.cache.dat
del /s %HDS_PROJECT_DIR%\*_entity.vhd %HDS_PROJECT_DIR%\*_struct.vhd %HDS_PROJECT_DIR%\*_fsm.vhd
REM del /s %HDS_PROJECT_DIR%\*.vhg

REM ----------------------------------------------------------------------------
REM Launch Application
REM
REM %windir%\system32\cmd.exe /c start %HDS_HOME%\bin\hdldesigner.exe
start %HDS_HOME%\bin\hdldesigner.exe
